#include<stdio.h>
#include<conio.h>
#include<math.h>
#include<string.h>
#include<stdlib.h>
#include<windows.h>
#include<time.h>
#include<dos.h>
#include "gps.h"

double start_time,end_time,reading_time;
double prog_start_time,prog_end_time,prog_time;
extern GPS gps;

HANDLE gps_handle;

int buff_ptr=0;
char GPGGA[max_size];
char GPVTG[max_size];
char  gps_received_data[10*max_size]="";

int gps_info(char* gps_buff_sample)
{
	int i,j,k,counter,buff_len;
    char  timeString[12*2];
    char  latitudeString[11*2];
    char  longitudeString[12*2];
	char  satelliteNo[3*2],positionFix[2*2];
	char  arcDeg[7*2];
	char  groundSpeed[7*2];
	char  altitude[7*2];
	char  gpgga_chksum[3*2],gpvtg_chksum[3*2];
	char  temp[3*max_size];
	int gpgga_f,gpvtg_f;
	int data_available=0;

	printf("\nProcessing GPS string");

	buff_len=strlen(gps_received_data);
	j=0;
	gpgga_f=0;
	gpvtg_f=0;
	/*for(i=buff_len;i<(int)strlen(gps_buff_sample);i++)
	{
		gps_received_data[i]=gps_buff_sample[j];
		j++;
	}
	gps_received_data[i]='\0';*/
	strcpy(gps_received_data,gps_buff_sample);

//recheckbuff:
	FILE *fp1,*fp2;
	fp1=fopen("gps_data.txt","a");
	fp2=fopen("gps_log.txt","a");
	
	buff_len=strlen(gps_received_data);

  for(i=0;i<buff_len;i++)
  {
check_gpgga:
      if(gps_received_data[i]=='$' && gps_received_data[i+1]=='G' && gps_received_data[i+2]=='P' && gps_received_data[i+3]=='G' && gps_received_data[i+4]=='G' && gps_received_data[i+5]=='A')
       {
	           k=i;
			   j=0;
	           while(gps_received_data[k]!='*' && gps_received_data[k+1]!='\r' && gps_received_data[k+2]!='\n')
			   {
				    GPGGA[j]=gps_received_data[k];
					if(k+1>(int)strlen(gps_received_data))
					{
						printf("GPGGA string incomplete\n");
						//gps_received_data[0]='\0';
						return FALSE;
					}
				    k++;
				    j++;
			   }
			   GPGGA[j]=gps_received_data[k];
			   GPGGA[j+1]=gps_received_data[k+1];
			   GPGGA[j+2]=gps_received_data[k+2];
			   GPGGA[j+3]='\r';
			   GPGGA[j+4]='\n';
			   GPGGA[j+5]='\0';
			   gpgga_chksum[0]=GPGGA[j];
			   gpgga_chksum[1]=GPGGA[j+1];
			   gpgga_chksum[2]='\0';
			   gpgga_f=1;
		}

	   if(gps_received_data[i]=='$' && gps_received_data[i+1]=='G' && gps_received_data[i+2]=='P' && gps_received_data[i+3]=='V' && gps_received_data[i+4]=='T' && gps_received_data[i+5]=='G')
       {
			   if(gpgga_f==0)
			   {
				   i+=5;
				   goto check_gpgga;
			   }
			   j=0;
			   k=i;
	           while(gps_received_data[k]!='*' && gps_received_data[k]!='\r' && gps_received_data[k]!='\n')
			   {
				    GPVTG[j]=gps_received_data[k];
					if(k+1>(int)strlen(gps_received_data))
					{
						printf("GPVTG string incomplete\n");
						//gps_received_data[0]='\0';
						return FALSE;
					}
				    k++;
				    j++;
			   }
			   buff_ptr=k+4;
			   GPVTG[j]=gps_received_data[k];
			   GPVTG[j+1]=gps_received_data[k+1];
			   GPVTG[j+2]=gps_received_data[k+2];
			   GPVTG[j+3]='\r';
			   GPVTG[j+4]='\n';
			   GPVTG[j+5]='\0';
			   gpvtg_chksum[0]=GPVTG[j];
			   gpvtg_chksum[1]=GPVTG[j+1];
			   gpvtg_chksum[2]='\0';
			   gpvtg_f=1;
			   break;
	    }
  }
  if(i==buff_len)      return FALSE;
  if(gpgga_f==0 || gpvtg_f==0)   return FALSE;
  //if(gps_chksum(GPGGA,'r'))    return FALSE;
  //if(gps_chksum(GPVTG,'r'))	   return FALSE;
  printf("\nExtracted\n");
  printf("%s",GPGGA);
  printf("%s",GPVTG);
  
  fprintf(fp2,"%s",GPGGA);
  fprintf(fp2,"%s",GPVTG);
	  
	    for(i=0;i<(int)strlen(GPGGA);i++)
	    {
	         if(GPGGA[i]==',')
	         {
		          k=i+1;
				  break;
		     }
		}

       j=0;
		 while(GPGGA[k]!=',')
		 {
			 timeString[j]=GPGGA[k];
			 if(k+1>(int)strlen(GPGGA))     break;
			 k++;
			 j++;
		 }
		 timeString[j]='\0';

		sscanf_s(timeString, "%ld", &gps.utcTime);
	    gps.utcHour = (gps.utcTime/10000);   // extract Hours from long 
	    gps.utcMinutes = (gps.utcTime - (gps.utcHour*10000))/100;  // extract minutes from long 
	    gps.utcSeconds = gps.utcTime - (gps.utcHour*10000) - (gps.utcMinutes*100); // extract seconds from long 

	    if(gps.utcHour >= 0 && gps.utcHour <= 15)
             gps.sgtHour = gps.utcHour + 8;
		 else
             gps.sgtHour = gps.utcHour + 8 - 24;
	    gps.sgtMinutes = gps.utcMinutes;
	    gps.sgtSeconds = gps.utcSeconds;
		gps.sgtTime = (gps.sgtHour*60*60) + (gps.sgtMinutes*60) + (gps.sgtSeconds);

	    // NB: %02ld formats long to print 2 chars wide, padding with 0 if necessary 
	    printf("%02ld:%02ld:%02ld UTC = %02ld:%02ld:%02ld SGT\n", gps.utcHour, gps.utcMinutes, gps.utcSeconds, gps.sgtHour, gps.sgtMinutes, gps.sgtSeconds);

		 j=0;
		 k++;
		 while(GPGGA[k]!=',')
		 {
			 latitudeString[j]=GPGGA[k];
			 if(k+1>(int)strlen(GPGGA))     break;
			 k++;
			 j++;
		 }
		 latitudeString[j]='\0';

		sscanf_s(latitudeString, "%f", &gps.latitude);
	    gps.latDegrees = int(gps.latitude/100);
	    gps.latMinutes = float(gps.latitude - gps.latDegrees*100);
	    printf("\t%02d DEG\t%2.4f MIN\n", gps.latDegrees, gps.latMinutes);

		gps.latitude=gps.latDegrees+gps.latMinutes/60;

		 j=0;
		 k++;
		 while(GPGGA[k]!=',')
		 {
			 gps.latitudeCardinalString[j]=GPGGA[k];
			 if(k+1>(int)strlen(GPGGA))     break;
			 k++;
			 j++;
		 }
		 gps.latitudeCardinalString[j]='\0';
		 printf(" %s\n", gps.latitudeCardinalString);

		 j=0;
		 k++;
		 while(GPGGA[k]!=',')
		 {
			 longitudeString[j]=GPGGA[k];
			 if(k+1>(int)strlen(GPGGA))     break;
			 k++;
			 j++;
		 }
		 longitudeString[j]='\0';

        sscanf_s(longitudeString, "%f", &gps.longitude);
	    gps.longDegrees = int(gps.longitude/100);
	    gps.longMinutes = float(gps.longitude - gps.longDegrees*100);
	    printf("\t%03d DEG\t%2.4f MIN\n", gps.longDegrees, gps.longMinutes);
		gps.longitude=gps.longDegrees+gps.longMinutes/60;

		 j=0;
		 k++;
		 while(GPGGA[k]!=',')
		 {
			 gps.longitudeCardinalString[j]=GPGGA[k];
			 if(k+1>(int)strlen(GPGGA))     break;
			 k++;
			 j++;
		 }
		 gps.longitudeCardinalString[j]='\0';
		 printf(" %s\n", gps.longitudeCardinalString);

		 j=0;
		 k++;
		 while(GPGGA[k]!=',')
		 {
			 positionFix[j]=GPGGA[k];
			 if(k+1>(int)strlen(GPGGA))     break;
			 k++;
			 j++;
		 }
		 positionFix[j]='\0';

		 sscanf_s(positionFix, "%d", &gps.positionFix);
		 printf(" Position Fix : %d\n",gps.positionFix);

		 j=0;
		 k++;
		 while(GPGGA[k]!=',')
		 {
			 satelliteNo[j]=GPGGA[k];
			 if(k+1>(int)strlen(GPGGA))     break;
			 k++;
			 j++;
		 }
		 satelliteNo[j]='\0';

		 sscanf_s(satelliteNo, "%d", &gps.satelliteNo);
		 printf(" Number of Satellites : %d\n",gps.satelliteNo);
			
		 counter=0;
		 for(;k<(int)strlen(GPGGA);k++)
		 {
			 if(GPGGA[i]=',')
				 counter++;
			 if(counter==2)
				 break;
		 }

		 j=0;
		 k++;
		 while(GPGGA[k]!=',')
		 {
			 altitude[j]=GPGGA[k];
			 if(k+1>(int)strlen(GPGGA))     break;
			 k++;
			 j++;
		 }
		 altitude[j]='\0';
		 sscanf_s(altitude, "%f", &gps.altitude);

		 j=0;
		 k++;
		 while(GPGGA[k]!=',')
		 {
			 gps.unitOfAltitude[j]=GPGGA[k];
			 if(k+1>(int)strlen(GPGGA))     break;
			 k++;
			 j++;
		 }
		 gps.unitOfAltitude[j]='\0';

		 for(i=0;i<(int)strlen(GPVTG);i++)
	     {
	         if(GPVTG[i]==',')
	         {
		          k=i+1;
				  break;
		     }
		 }

         j=0;
		 while(GPVTG[k]!=',')
		 {
			 arcDeg[j]=GPVTG[k];
			 if(k+1>(int)strlen(GPVTG))     break;
			 k++;
			 j++;
		 }
		 arcDeg[j]='\0';

		 sscanf_s(arcDeg, "%f", &gps.arcDeg);

		 j=0;
		 k++;
		 while(GPVTG[k]!=',')
		 {
			 gps.courseRef[j]=GPVTG[k];
			 if(k+1>(int)strlen(GPVTG))     break;
			 k++;
			 j++;
		 }
		 gps.courseRef[j]='\0';
		 counter=0;
		 for(;k<(int)strlen(GPVTG);k++)
		 {
			if(GPVTG[k]==',')
				counter++;
			if(counter==5)
				break;
		 }

		 j=0;
		 k++;
		 while(GPVTG[k]!=',')
		 {
			 groundSpeed[j]=GPVTG[k];
			 if(k+1>(int)strlen(GPVTG))     break;
			 k++;
			 j++;
		 }
		 groundSpeed[j]='\0';
		 sscanf_s(groundSpeed, "%f", &gps.groundSpeed);

		 j=0;
		 k++;
		 while(GPVTG[k]!=',')
		 {
			 gps.unitOfSpeed[j]=GPVTG[k];
			 if(k+1>(int)strlen(GPVTG))     break;
			 k++;
			 j++;
		 }
		 gps.unitOfSpeed[j]='\0';
			
		 j=0;
		 for(i=buff_ptr+1;i<buff_len;i++)
		 {
		     temp[j]=gps_received_data[i];
			 j++;
		 }
		 temp[j]='\0';
		 strcpy(gps_received_data,temp);
		 gps_received_data[i]='\0';

		 if(gps.positionFix==0 || gps.satelliteNo<3)
		 {
			 gps_received_data[0]='\0';
			 return NO_LINK;
		 }

		 fprintf(fp1,"%ld %ld %ld ",gps.sgtHour,gps.sgtMinutes,gps.sgtSeconds);
		 fprintf(fp1,"%f %d %f ",gps.latitude,gps.latDegrees,gps.latMinutes);
		 fprintf(fp1,"%f %d %f",gps.longitude,gps.longDegrees,gps.longMinutes);
		 fprintf(fp1,"%d ",gps.arcDeg);
		 fprintf(fp1,"%d\n",gps.groundSpeed);

		 fclose(fp1);
		 fclose(fp2);
		
		 printf("\nGPS String processed");
		 data_available=1;
		 if(data_available==1)
			 return TRUE;
		 //goto recheckbuff;
		 return TRUE;
}


void gps_open_serial(int port)
{
   DWORD sec=gps_init_delay*1000;
   int seconds=gps_init_delay;
   char PORT_GPS[12]="\\\\.\\COM";
   char p[3];
   sprintf(p,"%d",port);
   strcat(PORT_GPS,p);
   gps_handle=CreateFile(PORT_GPS, GENERIC_READ | GENERIC_WRITE, 0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
   if (gps_handle == INVALID_HANDLE_VALUE)
   {
       printf("Gps Handle Error\n");
   }
   else
   {
       printf("Gps Connected to Serial\n");
   }

   DCB dcbS_gps = {0};
   dcbS_gps.DCBlength=sizeof(dcbS_gps);

   if(!GetCommState(gps_handle,&dcbS_gps))
   {
       if(GetLastError()== ERROR_FILE_NOT_FOUND)
       {
           printf("Gps Serial Port not found Error\n");
       }
       printf("Gps Status Error\n");
   }
   else
   {
       printf("Gps Status Received\n");
   }

   dcbS_gps.Parity=0;
   dcbS_gps.ByteSize = 8;//sets bit-size
   dcbS_gps.BaudRate = Baud_Rate_Gps;//sets baudrate

  //Sets timeout for reading - 0 = deactivate
   if(!SetCommState(gps_handle,&dcbS_gps))
   {
       printf("Serial Parameter Set Error\n");
   }
   else
   {
       printf("Serial Parameters Set\n");
   }

   COMMTIMEOUTS timeout_gps ={0};
   timeout_gps.ReadIntervalTimeout=3000;
   timeout_gps.ReadTotalTimeoutConstant=0;
   timeout_gps.ReadTotalTimeoutMultiplier=200;
   timeout_gps.WriteTotalTimeoutConstant=3000;
   timeout_gps.WriteTotalTimeoutMultiplier=200;

   if(!SetCommTimeouts(gps_handle, &timeout_gps))
   {
       printf("Gps Timeouts Set Error\n");
   }
   else
   {
       printf("Gps Timeouts Set\n");
   }
   PurgeComm(gps_handle, PURGE_RXCLEAR|PURGE_TXCLEAR);
   printf("GPS initialisation time : %d sec\n",seconds);
   Sleep(sec);
}

int gps_chksum(char *nmea_line,char rw)
{
  char *xor_chars = "0123456789ABCDEF";
  int chcount = 1, len_nmea;
  int xor = 0;

  len_nmea = strlen(nmea_line);
  while ( (chcount < len_nmea) && ( nmea_line[chcount] != '*') )
	 xor ^= (unsigned short int)(nmea_line[chcount++]);

  if ( nmea_line[chcount] != '*' ) return FALSE;

  printf("%d\n",xor);
  if(rw=='w')
  {
	nmea_line[chcount + 1] = xor_chars[xor >> 4];
	nmea_line[chcount + 2] = xor_chars[xor & 0x0F];
	nmea_line[chcount + 3] = '\r';
	nmea_line[chcount + 4] = '\n';
	nmea_line[chcount + 5] = '\0';
	return TRUE;
  }
  if(rw=='r')
  {
	if(	nmea_line[chcount + 1] == xor_chars[xor >> 4]&&
		nmea_line[chcount + 2] == xor_chars[xor & 0x0F] &&
		nmea_line[chcount + 3] == '\r' &&
		nmea_line[chcount + 4] == '\n' &&
		nmea_line[chcount + 5] == '\0')
		return TRUE;
  }
  return FALSE;
}

void gps_write()
{
	char gps_send_data[max_size]="$PMTK000*",gps_received_data[max_size];
	DWORD number_bytes;
	int counter=0;
	//PurgeComm(handle, PURGE_RXCLEAR|PURGE_TXCLEAR);
    //fp=fopen("gps_write.txt","a");

	if(gps_chksum(gps_send_data,'w')==0)
	{
		printf("Error in Gps check sum\n");
	}
	else
	{
		printf("Data to be sent to Gps: %s\n",gps_send_data);
	}
	
    PurgeComm(gps_handle, PURGE_RXCLEAR|PURGE_TXCLEAR);
	if(!WriteFile(gps_handle, gps_send_data, sizeof(gps_send_data), &number_bytes, NULL) != 0)
    {
        printf("Gps Serial Write Error\n");
    }
	if(ReadFile(gps_handle, gps_received_data, max_size, &number_bytes, NULL) == 0)
    {
        printf("Gps Serial Read Error\n");
    }
	else
	{
		printf("%s\n",gps_received_data);
	}	
}

void gps_read()
{
	char gps_buff_sample[max_size*2];
	int i=0,counter=0;
	DWORD number_bytes;
	int gps_status;

reread:
	if(ReadFile(gps_handle, gps_buff_sample, bytesRead, &number_bytes, NULL) == 0)
    {
        printf("Gps Serial Read Error\n");
    }
	else
	{
		gps_buff_sample[bytesRead]='\0';
		printf("\n%s\n",gps_buff_sample);
	}
	//printf("good\n");
	//PurgeComm(handle, PURGE_RXCLEAR|PURGE_TXCLEAR);
	
	gps_status=gps_info(gps_buff_sample);
	if(gps_status==0)
	{
		printf("Reinput Gps Data");
		counter++;
		if(counter>=10)
		{
			counter=0;
			printf("GPS improper data reception");
			return;
		}
	    goto reread;
	}
	else if(gps_status==-1)
	{
		counter++;
		if(counter>=10)
		{
			counter=0;
			printf("No Satellite Link\n");
			return;
		}
		goto reread;
	}
	printf("Buffer\n%s",gps_received_data);
}