#ifndef _initialize_H
#define _initialize_H
#pragma once

#include "gps.h"
#include "ins.h"
#include "kalman.h"
#include "matrix.h"

class INITIAL
{
public:
	INITIAL()
	{
		latitude=0.0;
		longitude=0;
		altitude=0;
		sgt_time=0;
		gps_fix=0;

		accl.x=0;
		accl.y=0;
		accl.z=0;
		angle.x=0;
		angle.y=0;
		angle.z=0;
		rate.x=0;
		rate.y=0;
		rate.z=0;
		pos.x=0;
		pos.y=0;
		pos.z=0;

		sgt_time=0;
		lat_sphere='N';
		long_sphere='E';

		/*accl = new xyz;
		pos = new xyz;
		rate = new xyz;
		angle = new xyz;*/
	}
	double latitude;
	char lat_sphere;
	double longitude;
	char long_sphere;
	double altitude;
	double sgt_time;
	int gps_fix;
	xyz pos;
	xyz accl;
	xyz angle;
	xyz rate;

	void initialize();
};


#endif