#ifndef matrix_H
#define matrix_H
#pragma once
#include "kalman.h"

#define parameters 3

class MATRIX
{
public:
	MATRIX :: MATRIX()
	{
		printf("Using default constructor of matrix");
	}
	MATRIX(int nrows,int ncols)
	{
		rows=nrows;
		cols=ncols;
		for(i=0;i<parameters*2;i++)
		{
			for(j=0;j<parameters*2;j++)
			{
				mat[i][j]=0;
			}
		}
	}
	double mat[parameters*2][parameters*2];
	int i,j;
	int rows;
	int cols;

	MATRIX operator *(MATRIX&);
	MATRIX operator *(double q);
	MATRIX operator +(MATRIX&);
	MATRIX operator +(double r);
	MATRIX operator -(MATRIX&);
	void operator =(MATRIX&);

	MATRIX transpose();
	void print_file_mat();
	void unit();
};
double determinant(MATRIX&);
MATRIX inverse(MATRIX&);
#endif