#include<stdio.h>
#include<conio.h>
#include<math.h>
#include<string.h>
#include<stdlib.h>
#include<windows.h>
#include<time.h>
#include<dos.h>
#include "accl.h"
#include "position.h"

#define Baud_Rate_Accl CBR_9600
#define buff_size 1
#define data_no 1
#define TRUE 1
#define FALSE 0

HANDLE accl_handle;

extern ACCL accl_data;

void accl_read(int start)
{
   char accl_sample_data[29]="",xval[8]="",yval[8]="",zval[8]="";
   struct xyz accl_sum={0.0,0.0,0.0};
   int i,j,k,p;
   double accl_buff[buff_size][3];
   FILE *fp;
   fp=fopen("accl.txt","a");
   if (fp==NULL)   printf("\nfile open error");
   DWORD number_bytes;

   for(i=0;i<buff_size;i++)
   {
	   for(j=0;j<3;j++)
	   {
		   accl_buff[i][j]=0.0;
	   }
   }
 
  accl_data.end_time=GetTickCount();
  printf("\nstart time : %f",accl_data.start_time);
  printf("\nend time : %f\n",accl_data.end_time);
  accl_data.reading_time=fabs(accl_data.start_time-accl_data.end_time)/1000;

  if(start==1)
  {
	  ReadFile(accl_handle, accl_sample_data,29, &number_bytes, NULL);
	  accl_data.reading_time=0;
  }
  accl_data.start_time=GetTickCount();

for(p=0;p<buff_size;p++)
{
read:
  if(ReadFile(accl_handle, accl_sample_data,29, &number_bytes, NULL) == 0)
  {
      printf("Serial Read Error\n");
	  goto read;
  }
  else
  {
      printf("Recieved: %s\n",accl_sample_data);
  }
  /*if (start==2)
  {
      start_time=GetTickCount();
	  goto skip_init;
  }*/

//skip_init:
  PurgeComm(accl_handle, PURGE_RXCLEAR|PURGE_TXCLEAR);
  
  for(i=0;i<23;i++)
  {
	  if((accl_sample_data[i]=='x' || accl_sample_data[i]=='X') && accl_sample_data[i+1]=='=' && (accl_sample_data[i+2]==' ' || accl_sample_data[i+2]=='-'))
	  {
		  k=0;
		  for(j=2;j<8;j++)
		  {
			  xval[k]=accl_sample_data[i+j];
			  k++;
		  }
		  xval[k]='\0';
	  }
  }
  for(i=0;i<23;i++)
  {
	  if((accl_sample_data[i]=='y' || accl_sample_data[i]=='Y') && accl_sample_data[i+1]=='=' && (accl_sample_data[i+2]==' ' || accl_sample_data[i+2]=='-'))
	  {  
		  k=0;
		  for(j=2;j<8;j++)
		  {
			  yval[k]=accl_sample_data[i+j];
			  k++;
		  }
		  yval[k]='\0';
	  }
  }
  for(i=0;i<23;i++)
  {
	  if((accl_sample_data[i]=='z' || accl_sample_data[i]=='Z') && accl_sample_data[i+1]=='=' && (accl_sample_data[i+2]==' ' || accl_sample_data[i+2]=='-'))
	  {  
		  k=0;
		  for(j=2;j<8;j++)
		  {
			  zval[k]=accl_sample_data[i+j];
			  k++;
		  }
		  zval[k]='\0';
	  }
  }
  accl_buff[p][0]=atof(xval);
  accl_buff[p][1]=atof(yval);
  accl_buff[p][2]=atof(zval);
}

for(p=0;p<buff_size;p++)
{
	accl_data.accl_sum.x=accl_data.accl_sum.x+accl_buff[p][0];
	accl_data.accl_sum.y=accl_data.accl_sum.y+accl_buff[p][1];
	accl_data.accl_sum.z=accl_data.accl_sum.z+accl_buff[p][2];
}
//getchar();

  //printf("%s %s %s\n",xval,yval,zval);

  accl_data.accl_accl.x = (accl_data.accl_sum.x/buff_size)*9.8312;   //std g=9.80665
  accl_data.accl_accl.y = (accl_data.accl_sum.y/buff_size)*9.8312;
  accl_data.accl_accl.z = (accl_data.accl_sum.z/buff_size)*9.8312;

  printf("Before Change Acceleration : %f %f %f\n",accl_data.accl_accl.x,accl_data.accl_accl.y,accl_data.accl_accl.z);
  fprintf(fp,"%f %f %f",accl_data.accl_accl.x,accl_data.accl_accl.y,accl_data.accl_accl.z);

  if(start ==2)
  {
	  /*accl_init.x=accl_accl.x;
	  accl_init.y=accl_accl.y;
	  accl_init.z=accl_accl.z;*/
	  accl_data.accl_prev_vel.x=accl_data.accl_accl.x*accl_data.reading_time;
	  accl_data.accl_prev_vel.y=accl_data.accl_accl.y*accl_data.reading_time;
	  accl_data.accl_prev_vel.z=accl_data.accl_accl.z*accl_data.reading_time;
	  return;
  }

  /*accl_accl.x=accl_accl.x-accl_init.x;
  accl_accl.y=accl_accl.y-accl_init.y;
  accl_accl.z=accl_accl.z-accl_init.z;*/

  printf("Acceleration : %f %f %f\n",accl_data.accl_accl.x,accl_data.accl_accl.y,accl_data.accl_accl.z);		  
  
  accl_data.accl_vel.x= accl_data.accl_accl.x*accl_data.reading_time+accl_data.accl_prev_vel.x;
  accl_data.accl_vel.y= accl_data.accl_accl.y*accl_data.reading_time+accl_data.accl_prev_vel.y;
  accl_data.accl_vel.z= accl_data.accl_accl.z*accl_data.reading_time+accl_data.accl_prev_vel.z;

  accl_data.accl_pos.x = accl_data.accl_prev_vel.x*accl_data.reading_time+0.5*accl_data.accl_accl.x*accl_data.reading_time;
  accl_data.accl_pos.y = accl_data.accl_prev_vel.y*accl_data.reading_time+0.5*accl_data.accl_accl.y*accl_data.reading_time;
  accl_data.accl_pos.z = accl_data.accl_prev_vel.z*accl_data.reading_time+0.5*accl_data.accl_accl.z*accl_data.reading_time;

  /*accl_pos.x = accl_vel.x*reading_time+accl_prev_pos.x;
  accl_pos.y = accl_vel.y*reading_time+accl_prev_pos.y;
  accl_pos.z = accl_vel.z*reading_time+accl_prev_pos.z;*/
  
  //fprintf(fp," %f %f %f",accl_pos.x,accl_pos.y,accl_pos.z);
  printf("Position :%f %f %f\n",accl_data.accl_pos.x,accl_data.accl_pos.y,accl_data.accl_pos.z);
  fprintf(fp," %f\n",(accl_data.end_time-accl_data.prog_start_time)/1000);
  printf("Time : %f\n",accl_data.reading_time);

  accl_data.accl_prev_vel=accl_data.accl_vel;
  accl_data.accl_prev_pos=accl_data.accl_pos;

    fclose(fp);
}

void accl_open_serial(int port)
{
   char PORT_ACCL[12]="\\\\.\\COM";
   char p[3];
   sprintf(p,"%d",port);
   strcat(PORT_ACCL,p);
   accl_handle = CreateFile(PORT_ACCL, GENERIC_READ | GENERIC_WRITE, 0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
   if (accl_handle == INVALID_HANDLE_VALUE)
   {
       printf("Accl Handle Error\n");
   }
   else
   {
       printf("Accl Connected to Serial\n");
   }

   DCB dcbS_accl = {0};
   dcbS_accl.DCBlength=sizeof(dcbS_accl);

   if(!GetCommState(accl_handle,&dcbS_accl))
   {
       if(GetLastError()== ERROR_FILE_NOT_FOUND)
       {
           printf("Accl Serial Port not found Error\n");
       }
       printf("Accl Status Error\n");
   }
   else
   {
       printf("Accl Status Received\n");
   }

   dcbS_accl.Parity=0;
   dcbS_accl.ByteSize = 8;//sets bit-size
   dcbS_accl.BaudRate = Baud_Rate_Accl;//sets baudrate

//Sets timeout for reading - 0 = deactivate
   if(!SetCommState(accl_handle,&dcbS_accl))
   {
       printf("Serial Parameter Set Error\n");
   }
   else
   {
       printf("Serial Parameters Set\n");
   }

   COMMTIMEOUTS timeout_accl ={0};
   timeout_accl.ReadIntervalTimeout=3000;
   timeout_accl.ReadTotalTimeoutConstant=0;
   timeout_accl.ReadTotalTimeoutMultiplier=200;
   timeout_accl.WriteTotalTimeoutConstant=3000;
   timeout_accl.WriteTotalTimeoutMultiplier=200;

   if(!SetCommTimeouts(accl_handle, &timeout_accl))
   {
       printf("Accl Timeouts Set Error\n");
   }
   else
   {
       printf("Accl Timeouts Set\n");
   }
  PurgeComm(accl_handle, PURGE_RXCLEAR|PURGE_TXCLEAR);
}